var Dom = YAHOO.util.Dom,
Event = YAHOO.util.Event,
Lang = YAHOO.lang;

Event.on(document, 'mousedown', function(ev) {
	if (nodeOrAncestorHasClass(Event.getTarget(ev), 'actions-menu')) {
		return true;
	}

	hideAllMenus();
});
		 
function hideAllMenus() {
	Dom.setStyle(Dom.getElementsByClassName('actions-menu'), 'display', 'none');	
}

function nodeOrAncestorHasClass(idOrEl, className) {
	 var el = Dom.get(idOrEl);
	 while (el != null) {
		if (Dom.hasClass(el, className)) {
			return true;
		}
		 if (el.tagName.toLowerCase() == 'body') {
			return false;
		}

		el = el.parentNode;
	 }
	 return false;
}

function removeMessage(msgId, containerId) {
    windowBlind(Dom.get(containerId), Dom.get(msgId), false, true);    
}

function appendMessage(msgEl, containerId, index) {
    var containerDiv = Dom.get(containerId);

	if (!Lang.isValue(index)) {
		setVisibleWithFade(msgEl, .5, containerDiv, index);
	} else {
		windowBlind(containerDiv, msgEl, true, true, false, index);	
	}
}

function windowBlind(containerDiv, childDiv, show, heightIsAuto, duration, index) {
    if (!show) {
        var anim = new YAHOO.util.Anim(childDiv, { height: { to: 0 }, opacity: {to: 0}}, duration || 0.4);
        anim.onComplete.subscribe(function() {
								  
		  containerDiv.removeChild(childDiv);
								  Dom.setStyle(childDiv, 'opacity', '1');								  
								  Dom.setStyle(childDiv, 'height', 'auto');
		});
        anim.animate();
    } else {
        if (heightIsAuto) {
            Dom.setStyle(childDiv, 'height', 'auto');
        }
		
        // We need to append the element initially so we can get the height that it will be.
        // Then immediately set it back to height 0 so it can grow.
        if (!Lang.isValue(index)) {
            containerDiv.appendChild(childDiv);
        } else {
            containerDiv.insertBefore(childDiv, containerDiv.childNodes[index]);
        }
        
        childDiv.finalAnimatedHeight = childDiv.clientHeight;
        Dom.setStyle(childDiv, 'height', '0');
        Dom.setStyle(childDiv, 'opacity', '0');
        var anim = new YAHOO.util.Anim(childDiv, { height: { to: childDiv.finalAnimatedHeight }, opacity: {to: 1}}, duration || 0.4);
        anim.onComplete.subscribe(function() {
		  if (heightIsAuto) {
			  Dom.setStyle(childDiv, 'height', 'auto');
		  }
		});
        anim.animate();
    }
}

function setVisibleAndFadeAway(idOrElement, showDurationInMillis, fadeInDurationSeconds, fadeOutDurationSeconds, displayType) {
    var self = this;
    var showDur = showDurationInMillis || 2000;
    var fadeIn = fadeInDurationSeconds || 0.1;
    var fadeOut = fadeOutDurationSeconds || 0.5;
    var display = displayType || 'block';
    
    setVisibleWithFade(idOrElement, fadeIn, display, function() {
	   setTimeout(function() {
				  self.setHiddenWithFade(idOrElement, fadeOut); 
				  }, showDur);
	   });
	
}


function setVisibleWithFade(el, fadeDurationSeconds, containerDiv, index, displayType, onComplete) {
    var fadeDur = fadeDurationSeconds || 0.4;            
    var display = displayType || 'block';
	
    Dom.setStyle(el, 'opacity', 0);
    if (!Lang.isValue(index)) {
        containerDiv.appendChild(el);
    } else {
        containerDiv.insertBefore(el, containerDiv.childNodes[index]);
    }	
    
    var attributes = { opacity: { to: 1 } };            
    var anim = new YAHOO.util.Anim(el, attributes, fadeDur, YAHOO.util.Easing.easeOut);
    if (onComplete) {
        anim.onComplete.subscribe(onComplete);
    }
    anim.animate();
}

function setHiddenWithFade(idOrElement, fadeDurationSeconds, onComplete) {
    var el = Dom.get(idOrElement);
    if (!el) {
        return;
    }
	
    var fadeDur = fadeDurationSeconds || 0.5;   
    
    var attributes = { opacity: { to: 0 } };            
    var anim = new YAHOO.util.Anim(el, attributes, fadeDur, YAHOO.util.Easing.easeOut);
    anim.onComplete.subscribe(function() {
							  Dom.setStyle(el, "display", "none");
							  Dom.setStyle(el, "opacity", "1");
							  if (onComplete) {
							  onComplete();
							  }
							  });
    anim.animate();
}
